/**
 Timeserver Library
 Ideen dazu von https://circuits4you.com 
 Erweitert durch Reiner Hornischer
 http://www.hornischer.net
*/

#ifndef __TIMESERVER__
#define __TIMESERVER__

#include <Arduino.h>
#include <WiFiUdp.h>
#include <ESP8266WiFi.h>

class Timeserver{	
private:
		IPAddress timeServerIP;
		unsigned int localPort = 2390; //local UDP - Port
		static const int NTP_PACKET_SIZE = 48; // NTP time stamp is in the first 48 bytes of the message
		byte packetBuffer[ NTP_PACKET_SIZE]; //buffer to hold incoming and outgoing packets
		WiFiUDP udp;
	
public:
		const bool UNIT = false;
		const bool NO_UNIT = true;
		Timeserver (IPAddress timeServerIP);
		/*Timeserver ();
		void connect(String ntpServerName);*/
		unsigned long requestTime();
		int getYear();
		int getMonth();
		int getDay();
		int getHour();
		int getMinute();
		int getSecond();
		String timeString(bool raw, bool recalc);
		String dateString(bool recalc);
		String dateTimeString(bool raw);
		unsigned long dateTime();
		
private:
		// send an NTP request to the time server at the given address
		unsigned long sendNTPpacket(IPAddress& address);
		bool isSchaltjahr();
		void calcyear();
		void calcmonth();
		void calcday();
		void calcTime();
		String niceTime(int t);
		int calcDoW(int d, int m, int y);
		bool isSummerTime();
};

#endif